/**
 * This JavaScript file contains code that will be called upon the start of 
 * Kobold Adventure.
 */

$( document ).ready(function() {
    global.init();
    global.sceneLoader.loadScene("TitleScreen");
    // Initial autosave.
    if(!global.saveManager.hasAutoSave()){
        global.saveManager.autoSave();
    }
    // Initial start game save.
    global.saveManager.newGameSave();
    
    // Hide loading screen.
    global.ui.hideLoadingScreen();
});
