/**
 * Watch section of the bandit encounter.
 * @param {ForestController} controller The forest controller.
 */
function ForestBanditWatch(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var toMasturbate = new ForestBanditMasturbate(controller);
    var toKeepWatching = new ForestBanditKeepWatching(controller);
    var toSteal = new ForestBanditSteal(controller);

    var masturbateId = "banditMasturbateButton";
    var watchId = "banditKeepWatchingButton";
    var stealId = "banditStealStuffButton";

    var content = ` <div class="text">
                        While you <span class="bold">would</span> like to help the poor dragoness, 
                        there is simply nothing you can do against a gang of five of your peers,
                        at least one of which is armed.
                        Besides, you don't want to risk losing your bag of freshly-acquired gold.
                        Still, you decide to stick around for just a little while longer, just to see the situation play out further.
                        There might still be something for you to gain out of this situation.
                    </div>
                    <div class="text">
                        As the dragoness' reluctant submission sinks in, the kobolds immediately begin to abuse her.
                        Tears flow down the woman's cheeks as her ${global.kobold.inventory.createItemWithTooltip(new RedDress())} gets lifted, 
                        one of her assailants sticking his head underneath the fine fabric,
                        the full extent of her long, scaly blue legs as well as
                        her fancy ${global.kobold.inventory.createItemWithTooltip(new SilkPanties())} now fully exposed to him.
                    </div>
                    <div class="text">
                        The nude kobold, meanwhile, has begun to grope one of the lady's breasts through her clothing.
                        He rubs, squeezes and caresses the sensitive mound to his heart's content, 
                        visibly discomforting the dragoness whilst openly stroking himself.
                        A single droplet of precum drips from the very tip of his cock down ontop of her arm, 
                        the liquid instantly seeping into her dress, matting the once-pristine garment.
                    </div>
                    <div class="text">
                        The male in charge of her left leg seems to have taken an interest in the woman's foot, 
                        lowering his ${global.kobold.inventory.createItemWithTooltip(new LoinCloth())} whilst pressing his muzzle against her sole,
                        seemingly inhaling deeply as his eyes roll to the back of his head.
                        He intently begins to rub the slit between his legs with two of his fingers, 
                        the tapered tip of his member already protruding from it, 
                        growing more erect with every passing second.
                    </div>
                    <div class="text">
                        The ringleader decides it's time to move things along.
                        Out of the sleeve of his ${global.kobold.inventory.createItemWithTooltip(new PaddedLeatherShirt())},
                        he produces a second weapon: a sharp ${global.kobold.inventory.createItemWithTooltip(new Dagger())}.
                        He passes the pointy blade to the only member of the gang that hasn't gotten naked yet.
                        After the two exchange a mutual nod, the now-armed kobold climbs atop the woman's body,
                        straddling her chest, pressing the dagger against her bosom.
                    </div>
                    <div class="text">
                        For a moment, you feared he'd sunk the blade directly into her very heart.
                        A wave of relief washes over you as you realize he was simply cutting apart her clothing, 
                        ripping it with one clawed hand whilst slicing it with the dagger, 
                        the ${global.kobold.inventory.createItemWithTooltip(new RedDress())} rapidly reduced to mere shreds,
                        more and more of dragoness' enticing, curvy body coming into view with every scrap of fabric removed.
                    </div>
                    <div class="text">
                        Her ${global.kobold.inventory.createItemWithTooltip(new LinenBra())} gets torn along with her dress,
                        the woman's blue-scaled tits with dark black nipples now in plain sight.
                        The kobold playing with one of her breasts redoubles his efforts,
                        digging his fingers into her supple flesh, 
                        harshly pinching her bare nipple and rubbing his member against the side of her boob,
                        prodding into it ever so slightly whilst wiping off a fresh buildup of pre onto her scales, 
                        slickening them for further frottage.
                    </div>
                    <div class="text">
                        His underlings occupied, and the lady sufficiently pacified for the moment,
                        the leader removes his knife from her throat, sticking it in the ground right besides her head,
                        to remind her that things can still turn violent at his behest.
                        After warning her not to scream, he removes the loincloth from her mouth.
                        To your surprise, the dragoness complies, 
                        too intimidated and overwhelmed by the group molestation to utter even a single word.
                    </div>
                    <div class="text">
                        The ringleader removes his pants, tosses them aside and mounts the woman's face, 
                        taking hold of her small, nubby horns and using them as handlebars to lift her head upwards, 
                        forcing her muzzle into his groin. 
                        Grinding his cockslit against her lips and her nose,
                        he pre-emptively silences whatever plea she was preparing to utter.
                    </div>`;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the main content of this section.
     * @returns {string} The main content of this section.
     */
    function buildContent() {
        return content;
    }

    /**
     * Builds and returns the masturbate button.
     */
    function buildMasturbateChoice() {
        var disabled = ctrl.bandit.watch.hasMadeWatchChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.watch.getWatchChoice() == ForestBanditWatchChoiceEnum.MASTURBATE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${masturbateId}" ${disabled}>Masturbate</button>`;

        var tooltip = `Watching a group of kobolds having their way with a dragoness is rather arousing. Quietly let off some steam while watching from the shadows.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 250px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the keep watching button.
     */
    function buildKeepWatchingChoice() {
        var disabled = ctrl.bandit.watch.hasMadeWatchChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.watch.getWatchChoice() == ForestBanditWatchChoiceEnum.KEEPWATCHING;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${watchId}" ${disabled}>Keep watching</button>`;

        var tooltip = `Wait until the gang has finished up their business before making a move.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip);
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the steal stuff button.
     */
    function buildStealStuffChoice() {
        var disabled = ctrl.bandit.watch.hasMadeWatchChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.watch.getWatchChoice() == ForestBanditWatchChoiceEnum.STEAL;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${stealId}" ${disabled}>Steal stuff</button>`;

        var tooltip = `While the kobolds are occupied, you may be able to sneak up on them and steal some of their stuff. 
                       You <span class="italic">are</span> a thief, after all.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 220px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildMasturbateChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildKeepWatchingChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildStealStuffChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + masturbateId), $("#" + watchId), $("#" + stealId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the masturbate button.
     */
    function registerMasturbateListener() {
        $("#" + masturbateId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.watch.makeWatchChoice(ForestBanditWatchChoiceEnum.MASTURBATE);
            loadNextPart(toMasturbate);
        });

    }

    /**
     * Adds a listener to the keep watching button.
     */
    function registerKeepWatchingListener() {
        $("#" + watchId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.watch.makeWatchChoice(ForestBanditWatchChoiceEnum.KEEPWATCHING);
            loadNextPart(toKeepWatching);
        });
    }

    /**
     * Adds a listener to the steal button.
     */
    function registerStealStuffListener() {
        $("#" + stealId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.watch.makeWatchChoice(ForestBanditWatchChoiceEnum.STEAL);
            loadNextPart(toSteal);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "banditWatch";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.bandit.getArrivalChoice() !== ForestBanditArrivalChoiceEnum.WATCH) {
            return "";
        }
        ctrl.bandit.watch.watchShared();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        part += toMasturbate.build();
        part += toKeepWatching.build();
        part += toSteal.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.bandit.getArrivalChoice() !== ForestBanditArrivalChoiceEnum.WATCH) {
            return;
        }

        toMasturbate.registerListeners();
        toKeepWatching.registerListeners();
        toSteal.registerListeners();

        if (ctrl.bandit.watch.hasMadeWatchChoice()) {
            return;
        }

        registerMasturbateListener();
        registerKeepWatchingListener();
        registerStealStuffListener();
    };
}

/**
 * Choices for the watching part of the bandit encounter.
 */
var ForestBanditWatchChoiceEnum = {
    MASTURBATE: 1,
    KEEPWATCHING: 2,
    STEAL: 3
};
